var fileCartInstance = [];
angular.module('ngApp').controller('fileShopCtrl', function ($scope, $ionicModal, $http, $ionicScrollDelegate, fileCheckoutService, $ionicPopup, $ionicLoading, $sce, localStorage, $rootScope, fileCheckoutService) {
	$rootScope.fileCheckoutService = fileCheckoutService;
	$scope.products = [];
	$scope.storage = '';
	$scope.noMoreItemsAvailable = true;
	$scope.slideIndex = 0;

	setTimeout(function() {
		updateFileCartInstances();
	}, 1000);

	$scope.fileCheckoutService = fileCheckoutService;
	// Wait until the sl var is init
	$scope.$watch('sl', function () {
		$scope.showProducts(false);
	});

	$scope.showProducts = function(refresh) {
		// Load news
	  if(isOnline()){
		if(!refresh){
		  $scope.loading = true;
		}
		$http({method: 'GET', noLoading : true, url: url + '/api/v1/widget/route/file-shop/getProduct/' + $scope.sl})
		.success(function(data) {
			if (data.start_content) {
				$scope.start_content = data.start_content;
			}
			if(data.products)
			{
				$scope.products = data.products;
				if(data.products.length == 6){
					$scope.noMoreItemsAvailable = false;
				}
				$scope.storage = data.error;
			}else{
				$scope.storage = 'خطا در بارگذاری محصولات';
			}
			$scope.loading = false;
			$scope.$broadcast('scroll.refreshComplete');
		})
		.error(function() {
			$scope.storage = 'خطا در بارگذاری محصولات';
			$scope.loading = false;
			$scope.$broadcast('scroll.refreshComplete');
		});
	  }else{
		$scope.loading = false;
		showToast("اتصال اینترنت خود را بررسی کنید");
	  }
	};

	$scope.doRefresh = function() {
		$scope.showProducts(true);
		//$scope.noMoreItemsAvailable = false;
	};

	$scope.loadMore = function() {
		if(!$scope.noMoreItemsAvailable){
			$scope.noMoreItemsAvailable = true;
			var start = $scope.products.length;
			if(isOnline()){
				$scope.infiniteScrollLoading = true;
				$http({method: 'GET', noLoading : true, url: url + '/api/v1/widget/route/file-shop/getProduct/' + $scope.sl + '/' + start})
				.success(function(data) {
					if (data.products.length == 0)
					{
						$scope.noMoreItemsAvailable = true;
					}
					else
					{
						for (var i = 0 ; i < data.products.length ; i++)
						{
							$scope.products.push(data.products[i]);
						}
					}
					if(data.products.length < 6){
						$scope.noMoreItemsAvailable = true;
					}else{
						$scope.noMoreItemsAvailable = false;
					}
					$scope.infiniteScrollLoading = false;
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
				.error(function() {
					console.error('ERR', err.status);
					$scope.infiniteScrollLoading = false;
					$scope.$broadcast('scroll.infiniteScrollComplete');
				});
			}
		}
	};

	$ionicModal.fromTemplateUrl('file-product-modal.html', {
		scope: $scope,
		animation: 'slide-in-up',
		hardwareBackButtonClose: true
	}).then(function(modal) {
		$scope.modal = modal;
	});

	$scope.slideroptions = {
		preventClicks: false,
		preventClicksPropagation: false,
		autoplayDisableOnInteraction: false,
		loop: false,
		speed: 400,
		//autoHeight: true,
		autoplay: 7000,
		autoplayStopOnLast : true
	};

	$scope.openModal = function(index) {
		$scope.product = $scope.products[index];
		$scope.content = $sce.trustAsHtml($scope.product.description);
		$scope.fetureImage = ($scope.products[index].image != '') ? true : false;
		$('.swiper-pagination').show();
		if($scope.product.images.length == 1)
			setTimeout(function() {$('.swiper-pagination').hide()}, 100);
		$scope.inZoom = false;
		$scope.slideIndex = 0;
		$scope.modal.show();
		$rootScope.openModal = $scope.modal;
	};

	$scope.closeModal = function() {
		$scope.modal.hide();
		updateFileCartInstances();
	};

	$scope.$on('modal.hide', function() {
		$scope.content = '';
		$scope.product = [];
		$scope.slideIndex = 0;
		$scope.inZoom = false;
	});

	$scope.zoom = function(){
		if($scope.inZoom){
			$ionicScrollDelegate.$getByHandle('inner'+$scope.slideIndex).zoomTo(1,true);
			$scope.inZoom = false;
		}else{
			$ionicScrollDelegate.$getByHandle('inner'+$scope.slideIndex).zoomTo(2,true);
			$scope.inZoom = true;
		}
	}
	// Called each time the slide changes
	$scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
		if($scope.inZoom = true){
			$ionicScrollDelegate.$getByHandle('inner' + $scope.slideIndex).zoomTo(1,true);
			$scope.inZoom = false;
		}
		$scope.slideIndex = data.slider.activeIndex;
	});

	$scope.addToCart = function() {
		if($scope.provider == 'Zarinpal')
		{
			fileCart.add({
				id: $scope.product.id,
				name: $scope.product.title ,
				price: $scope.product.price ,
				thumb: $scope.product.thumb ,
				quantity: 1
			});
			fileCheckoutService.showModal();
		}
		else if($scope.provider == 'cafebazaar'){
			$scope.user = localStorage.all('user');
			var myPopup = $ionicPopup.show({
				template: '<input type="email" ng-model="user.email" required/>',
				title: 'لطفا ایمیل خود را وارد کنید',
				subTitle: '',
				scope: $scope,
				buttons: [
				  { text: 'انصراف' },
				  {
					text: '<b>پرداخت</b>',
					type: 'button-positive',
					onTap: function(e) {
					  if(!$scope.user.email) {
						e.preventDefault();
					  } else {
						localStorage.save($scope.user,'user');
						return $scope.user.email;
					  }
					}
				  }
				]
			});

			myPopup.then(function(res) {
				if(typeof res != 'undefined'){
					if(isDevice){
						$ionicLoading.show();
						inappbilling.init(function(){
							//success init
							inappbilling.buy($scope.successBuy, showError(purchaseMessage['fail']) ,$scope.product.iap_id);
							$ionicLoading.hide();
						}, function(){
							//error init
							showWarning('<h4> خطا در اتصال</h4> برای پرداخت باید به حساب کافه بازار خود وارد شوید');
							setTimeout(function() {
								window.open('bazaar://login', '_system');
							}, 3000);
						}, {showLog:false}, "com.farsitel.bazaar", "ir.cafebazaar.pardakht.InAppBillingService.BIND", RSA_key);
					}else{
						showWarning('این امکان فقط در فایل خروجی امکان پذیر است');
					}
				}
			});
		}
	};

	$scope.successBuy = function(result) {
		$ionicLoading.show();
		$.ajax({
			type        : 'POST',
			url         : url + '/api/v1/widget/post/file-shop/postCafeCheckPeyment?sl=' + $scope.sl,
			data        : { pId : $scope.product.id,
							email : $scope.user.email,
							packageName : result.packageName,
							productId : result.productId,
							purchaseToken : result.purchaseToken,
						  },
			dataType    : 'json',
			encode      : true
		})
		.done(function(data) {
			$ionicLoading.hide();
			if(typeof data.downloadurl != 'undefined' && data.error == ''){
				if(isDevice){
					//consume product
					inappbilling.consumePurchase(function(){}, function(){}, result.productId);

					$ionicPopup.alert({
						title: purchaseMessage['success'],
						template: '<a href="'+ data.downloadurl +'" target="_system"><button class="button button-positive button-block">دانلود</button></a>',
						buttons: []
				   });
				}else{
					//window.location = data.paymenturl;
					window.open(data.paymenturl, '_system');
				}
			}else{
				showError(data.error);
			}
		})
		.fail(function(data) {
			$ionicLoading.hide();
			checkYourInternet();
			$ionicPopup.alert({
				title: '',
				template: 'خطا در تایید خرید. اتصال اینترنت خود را بررسی کند و مجددا تلاش کنید.',
				buttons: [
				 {
					text: '<b>تلاش مجدد</b>',
					type: 'button-positive',
					onTap: function(e) {
					  $scope.successBuy(result);
					}
				  }
				]
			});
		});
	};
})
.filter('dashless',function() {
	return function(input) {
		if (input) {
			return input.replace(/-/g, ' ');
		}
	}
})
.filter('farsinum', function () {
	return function (input) {
		if (input && lang('global.locale') == 'fa') {
			input = input.replace(/0/g, '۰').replace(/1/g, '۱').replace(/2/g, '۲').replace(/3/g, '۳').replace(/4/g, '۴').replace(/5/g, '۵').replace(/6/g, '۶').replace(/7/g, '۷').replace(/8/g, '۸').replace(/9/g, '۹');
			return input + ' ' + lang('global.toman');
		}
		return input;
	}
});

angular.module('ngApp').service('fileCheckoutService', function($ionicModal,localStorage) {

	this.showModal = function() {

		var service = this;

		$ionicModal.fromTemplateUrl('file-checkout.html', {
			scope: null,
			animation: 'slide-in-up',
			hardwareBackButtonClose: true
		}).then(function(modal) {
			service.modal = modal;
			service.modal.checkout = service.checkout;
			service.modal.user = localStorage.all('user');
			service.modal.show();
			updateFileCartInstances();
		});
	};

	this.hideModal = function() {
		this.modal.hide();
		updateFileCartInstances();
	};

	this.checkout = function(modal) {
		$('.Fcart input,.Fcart textarea').removeClass('alert');
		$('#alert').hide();

		var email = modal.user.email;
		if(email != '' && validateEmail(email)){
			localStorage.save(modal.user,'user');
			fileCart.checkout();
		}else{
			$('#customer_email').addClass("alert");
			$('#alert').html("لطفا ایمیل خود را به طور صحیح وارد نمایید");
			$('#alert').show();
		}
	};
});


function updateFileCartInstances()
{
	fileCart.update();

	$('.item_price, .shop_price, .itemRow .item-price, .itemRow .item-total').each(function(index, element) {
		var price = parseFloat($(this).text().replace(/[^\d\.]/g, ''));
		$(this).html(fileCart.toCurrency(price));
	});
}
fileCart.extend({
	generateAndSendForm: function (opts) {

		angular.element($('ion-view')).injector().get("$ionicLoading").show();
		var windowReference = null;
		if (ionic.Platform.isIOS()) {
			windowReference = window;
		}
		$.ajax({
			type        : 'POST',
			url         : opts.action,
			data        : opts.data,
			dataType    : 'json',
			encode      : true
		})
		.done(function(data) {
			if (typeof data.paymenturl != 'undefined' && data.error == '') {
				openPaymentUrl(data.paymenturl);
			} else {
				alert(data.error);
			}
		})
		.fail(function(data) {
			showToast("اتصال اینترنت خود را بررسی کنید");
		})
		.always(function() {
			angular.element($('ion-view')).injector().get("$ionicLoading").hide();
		});
	}
});

function successPayEcommerce() {
	showSuccess('ممنون از خرید شما :)');
	fileCart.empty();
	window.location.hash = homeHash;
}

function errorPayEcommerce(){
	showError('کاربر گرامی پرداخت شما موفقیت آمیز نبود. لطفا دوباره امتحان کنید');
	window.location.hash = homeHash;
}

angular.module('ngApp').controller('fileShopProductCtrl', function($scope, $ionicScrollDelegate, fileCheckoutService, $ionicPopup, $ionicLoading, $sce,localStorage) {

	$scope.fileCheckoutService = fileCheckoutService;

	$scope.slideroptions = {
		preventClicks: false,
		preventClicksPropagation: false,
		autoplayDisableOnInteraction: false,
		loop: false,
		speed: 400,
		//autoHeight: true,
		autoplay: 7000,
		autoplayStopOnLast : true
	};

	$scope.product = product;
	$scope.content = $sce.trustAsHtml($scope.product.description);
	$scope.fetureImage = ($scope.product.image != '') ? true : false;
	$('.swiper-pagination').show();
	if($scope.product.images.length == 1)
		setTimeout(function() {$('.swiper-pagination').hide()}, 100);
	$scope.inZoom = false;
	$scope.slideIndex = 0;

	$scope.zoom = function(){
		if($scope.inZoom){
			$ionicScrollDelegate.$getByHandle('inner'+$scope.slideIndex).zoomTo(1,true);
			$scope.inZoom = false;
		}else{
			$ionicScrollDelegate.$getByHandle('inner'+$scope.slideIndex).zoomTo(2,true);
			$scope.inZoom = true;
		}
	}
	// Called each time the slide changes
	$scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
		if($scope.inZoom = true){
			$ionicScrollDelegate.$getByHandle('inner' + $scope.slideIndex).zoomTo(1,true);
			$scope.inZoom = false;
		}
		$scope.slideIndex = data.slider.activeIndex;
	});

	$scope.addToCart = function() {
		if($scope.provider == 'Zarinpal')
		{
			fileCart.add({
				id: $scope.product.id,
				name: $scope.product.title ,
				price: $scope.product.price ,
				thumb: $scope.product.thumb ,
				quantity: 1
			});
			fileCheckoutService.showModal();
		}
		else if($scope.provider == 'cafebazaar'){
			$scope.user = localStorage.all('user');
			var myPopup = $ionicPopup.show({
				template: '<input type="email" ng-model="user.email" required/>',
				title: 'لطفا ایمیل خود را وارد کنید',
				subTitle: '',
				scope: $scope,
				buttons: [
				  { text: 'انصراف' },
				  {
					text: '<b>پرداخت</b>',
					type: 'button-positive',
					onTap: function(e) {
					  if(!$scope.user.email) {
						e.preventDefault();
					  } else {
						localStorage.save($scope.user,'user');
						return $scope.user.email;
					  }
					}
				  }
				]
			});

			myPopup.then(function(res) {
				if(typeof res != 'undefined'){
					if(isDevice){
						$ionicLoading.show();
						inappbilling.init(function(){
							//success init
							inappbilling.buy($scope.successBuy, showError(purchaseMessage['fail']) ,$scope.product.iap_id);
							$ionicLoading.hide();
						}, function(){
							//error init
							showWarning('<h4> خطا در اتصال</h4> برای پرداخت باید به حساب کافه بازار خود وارد شوید');
							setTimeout(function() {
								window.open('bazaar://login', '_system');
							}, 3000);
						}, {showLog:false}, "com.farsitel.bazaar", "ir.cafebazaar.pardakht.InAppBillingService.BIND", RSA_key);
					}else{
						showWarning('این امکان فقط در فایل خروجی امکان پذیر است');
					}
				}
			});
		}
	};

	$scope.successBuy = function(result) {
		$ionicLoading.show();
		$.ajax({
			type        : 'POST',
			url         : url + '/api/v1/widget/post/file-shop/postCafeCheckPeyment?sl=' + $scope.sl,
			data        : { pId : $scope.product.id,
							email : $scope.user.email,
							packageName : result.packageName,
							productId : result.productId,
							purchaseToken : result.purchaseToken,
						  },
			dataType    : 'json',
			encode      : true
		})
		.done(function(data) {
			$ionicLoading.hide();
			if(typeof data.downloadurl != 'undefined' && data.error == ''){
				if(isDevice){
					//consume product
					inappbilling.consumePurchase(function(){}, function(){}, result.productId);

					$ionicPopup.alert({
						title: purchaseMessage['success'],
						
						buttons: [
							{
								text: '<b>دانلود</b>',
								type: 'button-positive',
								onTap: function(e) {
									window.open(data.downloadurl, "_system")
								}
							}
						]
				   });
				}else{
					window.open(data.paymenturl,'_system');
				}
			}else{
				showError(data.error);
			}
		})
		.fail(function(data) {
			$ionicLoading.hide();
			checkYourInternet();
			$ionicPopup.alert({
				title: '',
				template: 'خطا در تایید خرید. اتصال اینترنت خود را بررسی کند و مجددا تلاش کنید.',
				buttons: [
				 {
					text: '<b>تلاش مجدد</b>',
					type: 'button-positive',
					onTap: function(e) {
					  $scope.successBuy(result);
					}
				  }
				]
			});
		});
	};
})

angular.module('ngApp').controller('purchaseHistoryCtrl', ['$scope', '$http', function ($scope, $http) {
	$scope.init = init;
	$scope.reloadPurchaseHistory = reloadPurchaseHistory;
	$scope.loadMorePurchaseHistory = loadMorePurchaseHistory;

	function init(initData) {
		$scope.sl = initData.sl;
		$scope.purchaseHistory = [];
		$scope.hasMorePurchaseHistory = false;
		_fetchPurchaseHistory().then(function (r) {
			$scope.purchaseHistory = r;
		});
	}

	function reloadPurchaseHistory() {
		_fetchPurchaseHistory().then(function (r) {
			$scope.purchaseHistory = r;
			$scope.$broadcast('scroll.refreshComplete');
		});
	}

	function loadMorePurchaseHistory() {
		_fetchPurchaseHistory($scope.purchaseHistory.length).then(function (r) {
			$scope.purchaseHistory.push(r);
			$scope.$broadcast('scroll.infiniteScrollComplete');
		});
	}

	function _fetchPurchaseHistory(start, len) {
		var reqObj = {
			url: url + '/api/v1/widget/route/file-shop/getPurchaseHistory/' + $scope.sl,
			method: 'GET',
			params: {}
		};
		if (typeof start !== 'undefined') {
			reqObj.params.start = start;
		}
		if (typeof len !== 'undefined') {
			reqObj.params.len = len;
		}
		return $http(reqObj).then(function (r) {
			if (!r.data.success) {
				throw 'error';
			}
			var data = JSON.parse(JSON.stringify(r.data.payload.data));
			$scope.hasMorePurchaseHistory = r.data.payload.hasMoreItems;
			return data;
		}, function (e) {
			return [];
		});
	}
}]);